import { DynamoDBDocument } from "@webiny/aws-sdk/client-dynamodb";
import { Client } from "@webiny/api-elasticsearch";
import { createTable } from "../definitions";
import { Context, IManager } from "../types";
import { Entity } from "@webiny/db-dynamodb/toolbox";
import { ITaskResponse } from "@webiny/tasks/response/abstractions";
import { IIsCloseToTimeoutCallable, ITaskManagerStore } from "@webiny/tasks/runner/abstractions";
import { BatchReadItem, BatchWriteItem, BatchWriteResult } from "@webiny/db-dynamodb";
import { ITimer } from "@webiny/handler-aws/utils";
export interface ManagerParams<T> {
    context: Context;
    documentClient?: DynamoDBDocument;
    elasticsearchClient?: Client;
    isCloseToTimeout: IIsCloseToTimeoutCallable;
    isAborted: () => boolean;
    response: ITaskResponse;
    store: ITaskManagerStore<T>;
    timer: ITimer;
}
export declare class Manager<T> implements IManager<T> {
    readonly documentClient: DynamoDBDocument;
    readonly elasticsearch: Client;
    readonly context: Context;
    readonly table: ReturnType<typeof createTable>;
    readonly isCloseToTimeout: IIsCloseToTimeoutCallable;
    readonly isAborted: () => boolean;
    readonly response: ITaskResponse;
    readonly store: ITaskManagerStore<T>;
    readonly timer: ITimer;
    private readonly entities;
    constructor(params: ManagerParams<T>);
    getEntity(name: string): Entity<any>;
    read<T>(items: BatchReadItem[]): Promise<T[]>;
    write(items: BatchWriteItem[]): Promise<BatchWriteResult>;
}
